#include <windows.h>
#include <wsipx.h>

#include <stdio.h>
#include <string.h>
#include <conio.h>

void main (void)
{
	WORD	version;
	WSADATA	wsaData;
	SOCKET	s, newSocket;
	SOCKADDR_IPX	localAddr, remoteAddr;
	char receiveBuff[256];
	int bytesRec;
	int bytesToReceive;
	int error;
	int addrLen = sizeof (localAddr);
	int acceptAddrLen;
//	int optval;

	version = MAKEWORD (1,1);
	if (WSAStartup (version, &wsaData) == SOCKET_ERROR)
	{
		printf ("WSAStartup failed\n");
		return;
	}

	s = socket (AF_IPX, SOCK_STREAM, NSPROTO_SPX);
	if (s == INVALID_SOCKET)
	{
		error = WSAGetLastError ();
		printf ("Error %d on socket\n", error);
		WSACleanup ();
		return;
	}
	printf ("socket() successful\n");

	memset (&localAddr, 0, sizeof (localAddr));
	localAddr.sa_family = AF_IPX;
	localAddr.sa_socket = 0xA791;

	if (bind (s, (PSOCKADDR)&localAddr, sizeof (localAddr)) == SOCKET_ERROR)
	{
		error = WSAGetLastError ();
		printf ("Error %d on bind\n", error);
		closesocket (s);
		WSACleanup ();
		return;
	}
	printf ("bind() successful\n");

	if (listen (s, 1) == SOCKET_ERROR)
	{
		error = WSAGetLastError ();
		printf ("Error %d on listen\n", error);
		closesocket (s);
		WSACleanup ();
		return;
	}
	printf ("listen() successful\n");

	error = 0;

	while (!kbhit())
	{
		printf ("Accepting connections...\n");
		acceptAddrLen = sizeof (remoteAddr);
		newSocket = accept (s, (LPSOCKADDR)&remoteAddr, &acceptAddrLen);
		if (newSocket == INVALID_SOCKET)
		{
			error = WSAGetLastError ();
			printf ("Error %d on accept\n", error);
		}
		else
		{
			printf ("Connection accepted\n");
			bytesRec = recv (newSocket, receiveBuff, 4096, 0);
			printf ("returned from recv\n");
			if (bytesRec == SOCKET_ERROR)
			{
				error = WSAGetLastError ();
				printf ("Error %d on recv\n", error);
			}
			else if (bytesRec != 0) // if bytes == 0 connection was closed
			{
				bytesToReceive = (int) receiveBuff[0];
				if (bytesToReceive > 255)
				{
					strcpy (receiveBuff, "Error");
					printf ("Requested echo of %d bytes.  Too big for us.\n", bytesToReceive);
					send (newSocket, receiveBuff, strlen (receiveBuff), 0);
					closesocket (newSocket);
				}
				else
				{
					printf ("Requested echo of %d bytes.  Sending OK.\n", bytesToReceive);
					strcpy (receiveBuff, "OK");
					send (newSocket, receiveBuff, strlen (receiveBuff), 0);
					bytesRec = recv (newSocket, receiveBuff, 4096, 0);
					if (bytesRec == SOCKET_ERROR)
					{
						error = WSAGetLastError ();
						printf ("Error %d on recv\n", error);
						closesocket (newSocket);
					}
					else if (bytesRec != 0)
					{
						printf ("Echoing data\n");
						send (newSocket, receiveBuff, bytesRec, 0);
						closesocket (newSocket);
					}
					else
					{
						printf ("Connection closed before any data sent.  Press any key.\n");
						getch ();
					}
				}
			}
			else
			{
				printf ("Connection closed before any data sent.  Press any key.\n");
				getch ();
			}
		}
	}

	getch ();
	closesocket (s);
	WSACleanup ();
}